# HFIXWCS -- Add IRAF WCS keywords to Hectospec multispec image headers
# By Doug Mink, SAO Telescope Date Center
# May 25, 2007

procedure hfixwcs (images)

string	images = ""	{prompt="Input multispec image(s) to correct"}
bool	deltemp=yes	{prompt="Delete temporary list file (y or n)"}
bool	verbose=no	{prompt="Log progress (y or n)"}

begin
	bool vb
	file imin
	string ims, tchar, templist, arg

	if (!defpac ("wcstools")) {
	    wcstools (motd=no)
	    }

	ims = images
	vb = verbose

	if (ims == "") {
	    print ("HFIXWCS:  Add IRAF WCS keywords to multispec images")
	    print ("Usage: hfixwcs <input images>")
	    return
	    }

#  Make temporary list of input files
	tchar = substr (ims,1,1)
        if (tchar == '@') {
	    templist = substr (ims,2,100)
	    deltemp = no
	    }
	else {
	    templist = mktemp ("hlinlist")
	    files (ims, >templist)
	    }
#	print (templist)

	list = templist
	while (fscan (list,imin) != EOF) {

# Set IRAF WCS keywords so sarith and scombine treat aperture keywords properly
	    arg = imin // " wcsdim=2 wat0_001='system=equispec'"
	    arg = arg // " wat1_001='wtype=linear label=Wavelength units=Angstroms'"
	    arg = arg // " wat2_001='wtype=linear'"
	    sethead (arg)
	    if (vb) {
		print ("sethead ",arg)
		}
            }

# Delete list file if temporary and requested
	if (deltemp) {
	    delete (templist)
	    }
end
# May 25 2004	New task
